package overflow_subscriber

import "fmt"

type ChannelExistError struct {
	Channel string
}

// Error returns the formatted configuration error.
func (cee ChannelExistError) Error() string {
	return fmt.Sprintf("Subscriber: Channel[%q] is already subscribed.", cee.Channel)
}

type ChannelIsNotExistError struct {
	Channel string
}

// Error returns the formatted configuration error.
func (cinee ChannelIsNotExistError) Error() string {
	return fmt.Sprintf("Subscriber: Channel[%q] is not subscribed.", cinee.Channel)
}

type Subscriber interface {
	Start() error
	Stop()

	Subscribe(h SubscriberHandler) error
	Unsubscribe(h SubscriberHandler) error
}
